#ifndef AREA_TRANSFER_HPP
#define AREA_TRANSFER_HPP

#include "character_unit.hpp"
#include <godot_cpp/templates/hash_set.hpp>
#include <godot_cpp/classes/area3d.hpp>

namespace gd = godot;

class AreaTransfer : public gd::Area3D {
    GDCLASS(AreaTransfer, gd::Area3D);
    static void _bind_methods();
public:
    virtual void _ready() override;
	/** listener connected in _ready
	 * checks if 'body' is a CharacterUnit, and registers it in ready_units
	 */
    void _on_body_entered(gd::Node3D *body);
	/** listener connected in _ready
	 * checks if 'body is in the ready_units list, and removes it if so.
	 */
    void _on_body_exited(gd::Node3D *body);
	/** checks if ready_units contains all player units on the field right now
	 * loads next_scene
	 */
    void check_all_ready();
    void set_next_scene(gd::String path);
    gd::String get_next_scene() const;
private:
    gd::String next_scene{};
    gd::HashSet<CharacterUnit *> ready_units{};
};

#endif // !AREA_TRANSFER_HPP
